<?php

/*
 *	Copyright 2011-2013 Benjamin Ingle
 *	The PSyOPs framework is licensed 
 *	under the GNU LGPL, version 2.1
 *	http://www.gnu.org/licenses/old-licenses/lgpl-2.1.txt
 */
 

/** Include path **/
ini_set('include_path', ini_get('include_path').'\\Classes\\');
include 'lib\\swift_required.php'; 

$dow = (date('w'));

if ($dow == '1') {
	$d = 3;
} else {
	$d = 1;
}

$fnDate = date('Y-m-d', time()); // for filename
$yest = date('Y/m/d', mktime(0, 0, 0, date('m'), date('d') - $d, date('Y')));

$timeNow = date('H:i');
echo $timeNow;									// DEV
$filename = "Status 1 report";

if ($dow != '0' && $dow != '6') {					// WEEKEND CHECK

$serverName = "COS-DDMS2\ECI2";
$connectionOptions = array("Database"=>"Ensite","UID"=>"NetClient","PWD"=>"db_user", "ReturnDatesAsStrings" => 1);

$idConn = sqlsrv_connect($serverName, $connectionOptions);

	if($idConn === false ) {
		die(var_dump(sqlsrv_errors()));
	} 


$tsql = "select distinct(SalesOrderDetail.SalesOrderId) 
from SalesOrderDetail 
where SalesOrderDetail.StatusCode = '1'
	and (SalesOrderDetail.OrderDate = (?)
	or SalesOrderDetail.OrderDate = (?))";

$params = array($fnDate, $yest);
//print_r ($params);
$options = array("Scrollable" => SQLSRV_CURSOR_KEYSET);
//print_r ($options);
$getReport = sqlsrv_query($idConn, $tsql, $params, $options);

if ($getReport === false) {
	die(print_r(sqlsrv_errors()));
}

$numRows = 0;
$numRows = sqlsrv_num_rows($getReport);
if ($numRows == 0) {
	$fromName = "Complete Office";
	$fromAddr = "bingle@complete-office.com";
	$replyTo = "bingle@complete-office.com";
	$subj = "Nothing found for $filename";
	$body = "Nothing found for $filename";
	$recp = "bingle@complete-office.com";			// PRODUCTION
	$message = "The $filename for $fnDate was not found.";
	$semi_rand = md5(time());
	$mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";
	$headers = "From: $fromAddr";
	$headers .= "\nMIME-Version: 1.0\n" .
	"Content-Type: multipart/mixed;\n" .
	" boundary=\"{$mime_boundary}\"";
	"-{$mime_boundary}\n" .
	"Content-Type: text/plain; charset=\iso-8859-1\n" .
	"Content-Transfer-Encoding: 7bit\n\n";
	$message .= "\n\n";
	mail($recp, $subj, $message, $headers);
	
} else {
	
ob_start();

	echo ("
		<table border = '0' cellspacing='0' cellpadding='4' style='font-family:Arial, sans-serif;'>
		<thead>
		<tr><th style='background-color:#ECECEC;font-size:12px;font-weight:bold;color:#000000;'>Invoice</th>
		</tr></thead><tbody>
		");
	
		$i = 1;
		while ($row = sqlsrv_fetch_array($getReport, SQLSRV_FETCH_NUMERIC)) {
		
		// color alternate rows
		if( $odd = $i%2 ) { // $odd == 1; the remainder of dividing an odd number
		    $bgColor = 'BEBEBE';
		} else { // $odd == 0; nothing remains 
		    $bgColor = 'ECECEC';
		}
		
		$item = trim($row[0]).trim($row[1]);

		echo ("
		     <tr><td style='background-color:#$bgColor;font-size:12px;color:#000000;'>$row[0]</td>
		");
  		$i++;
	}		
	
	echo ("</tbody></table></form></html>");

$reportOutput = ob_get_contents();
ob_end_clean();

// Clean up
sqlsrv_free_stmt($getReport);
sqlsrv_close($idConn);

	
// Create the Transport
$transport = Swift_MailTransport::newInstance();

// Create the Mailer using your created Transport
$mailer = Swift_Mailer::newInstance($transport);
$message = Swift_Message::newInstance()

  // Give the message a subject
  ->setSubject($filename)

  // Set the From address with an associative array
  ->setFrom(array('bingle@complete-office.com' => 'Ingle, Ben'))
  
  // Set the To addresses with an associative array
   ->setTo(array('bingle@complete-office.com'))		// DEV

  // Give it a body
  ->setBody($reportOutput, 'text/html');
  
 
$numSent = $mailer->send($message);

}


exit;

}  							// END WEEKEND CHECK


	
?>

