<?php

/*
 *	Copyright 2011-2013 Benjamin Ingle
 *	The PSyOPs framework is licensed 
 *	under the GNU LGPL, version 2.1
 *	http://www.gnu.org/licenses/old-licenses/lgpl-2.1.txt
 */

/*	//DEBUG
 foreach($_POST as $key => $value)
 echo $key."=".$value;
*/	

include_once $_SERVER['DOCUMENT_ROOT'] . '/psyops_function.php';

if (array_key_exists('check_submit', $_POST)) {
	
$connect = connect_mysqli();
mysqli_select_db($connect, 'setup');

$cookie = ret_cookie($connect);
$repID = $cookie[0];
$level = $cookie[1];
unset($cookie);

$idConn = connect_sqlsrv();
	
$checkSubmit = $_POST['check_submit'];
$mfg = sanitize(strtoupper($_POST['mfg']));
$item = sanitize($_POST['item']);
	$itemNum = $mfg.$item;

$date = (date('Y-m-d'));
$filename = 'Item By Contract for '.$itemNum.' '.$date;	


// Redirect output to a clients web browser (Excel2007) 
//header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
//header("Content-Disposition: attachment; filename=".$filename.".xlsx" );
// Redirect output to a clients web browser (Excel 97-2003)
echo header("Content-Type: application/vnd.ms-excel");
echo header("Content-Disposition: attachment; filename=".$filename.".xls" );
echo header('Cache-Control: max-age=0');
 

if ($checkSubmit == 4) {						// DL ITEM ON CONTRACT


$tsql = "select CustomerPricePlan.PricePlan, CustomerPricePlanDetail.MACCode, CustomerPricePlanDetail.SKU, 
	CustomerPricePlanDetail.Price, ItemVendor.Cost	
from CustomerPricePlan, CustomerPricePlanDetail, Item, ItemVendor
where CustomerPricePlan.Id = CustomerPricePlanDetail.PricePlanId
	and CustomerPricePlanDetail.MACCode like (?)
	and CustomerPricePlanDetail.SKU like (?)
	and Item.Id = CustomerPricePlanDetail.ItemId
	and Item.Id = ItemVendor.ItemId
	and Item.PurchaseVendorType = ItemVendor.VendorType
	and Item.PurchaseVendorSequence = ItemVendor.Sequence";

$params = array($mfg, $item);

$options = array("Scrollable" => SQLSRV_CURSOR_KEYSET);
$getReport = sqlsrv_query($idConn, $tsql, $params, $options);

if ($getReport === false) {
	die(print_r(sqlsrv_errors()) );
}

/** Error reporting */
error_reporting(E_ALL);

/** Include path **/
ini_set('include_path', ini_get('include_path').'\\Classes\\');

/** PHPExcel */
include 'PHPExcel.php';

/** PHPExcel_Writer_Excel2007 */
include 'PHPExcel/Writer/Excel2007.php';

// Create new PHPExcel object
$objPHPExcel = new PHPExcel();

// Set properties
$objPHPExcel->getProperties()->setCreator("Benjamin Ingle");
$objPHPExcel->getProperties()->setLastModifiedBy("Benjamin Ingle");
$objPHPExcel->getProperties()->setTitle("Contract Detail");
$objPHPExcel->getProperties()->setSubject("Contract Detail");
$objPHPExcel->getProperties()->setDescription("Office 2002 XLS, generated using PHP classes.");
// Set column headers
$objPHPExcel->setActiveSheetIndex(0);
$objPHPExcel->getActiveSheet()->SetCellValue('A1', 'Cont');
$objPHPExcel->getActiveSheet()->SetCellValue('B1', 'ItemNum');
$objPHPExcel->getActiveSheet()->SetCellValue('C1', 'Price');
$objPHPExcel->getActiveSheet()->SetCellValue('D1', 'Cost');
$objPHPExcel->getActiveSheet()->SetCellValue('E1', 'GP %');

// Rename sheet
$objPHPExcel->getActiveSheet()->setTitle('Item by Contract - '.$itemNum);

$objPHPExcel->getActiveSheet()->getPageSetup()->setRowsToRepeatAtTopByStartAndEnd(1, 1);

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objPHPExcel->setActiveSheetIndex(0);

// Allow setting explicit text values (eg, dept needs leading zeroes)
$type = PHPExcel_Cell_DataType::TYPE_STRING;
// Add data
$numRows = 0;
$numRows = sqlsrv_num_rows($getReport);
	$i = 2;
	while ($row = sqlsrv_fetch_array($getReport, SQLSRV_FETCH_NUMERIC)) {
			$mfg = trim($row[1]);
			$item = trim($row[2]);
			$itemNum = $mfg.$item;
		$objPHPExcel->getActiveSheet()->setCellValue('A' . $i, $row[0]);
		$objPHPExcel->getActiveSheet()->getCell('B' . $i)->setValueExplicit($itemNum, $type);
		$objPHPExcel->getActiveSheet()->setCellValue('C' . $i, $row[3]);
		$objPHPExcel->getActiveSheet()->setCellValue('D' . $i, $row[4]);	
 		$objPHPExcel->getActiveSheet()->setCellValue('E' . $i, '=IF(C'.$i.'=0,"",(C'.$i.'-D'.$i.')/C'.$i.')');		// formula to calculate GP (can't be done in query)
		$i++;									// =IF(D2=0,C2,C2/D2)										
	}
	


// set columns to width by AutoSize (not perfect, but close enough)
$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);

// set certain columns to fixed width (AutoSize not close enough in this case)


$h = ($i - 1);

// can't figure out how to (or if we can) set Accounting format, using simple currency instead
$objPHPExcel->getActiveSheet()->getStyle('C2:D'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_CURRENCY_USD_SIMPLE);
// sets to proper percentage format, two digits to right of decimal
$objPHPExcel->getActiveSheet()->getStyle('E2:E'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_PERCENTAGE_00);
// formats as text, to stop dropping leading zeroes...doesn't appear to work, using setExplicit above when it puts data in the cell
//$objPHPExcel->getActiveSheet()->getStyle('B2:C'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_TEXT);
// right-align column I, to fix gp = 0
$objPHPExcel->getActiveSheet()->getStyle('A2:B'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
// right-align column B, to align account numbers
$objPHPExcel->getActiveSheet()->getStyle('C2:E'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
// freeze top row (must freeze X+1 - to freeze top row, call freezePane on A2)
$objPHPExcel->getActiveSheet()->freezePane('A2');


$highestRow = $objPHPExcel->getActiveSheet()->getHighestRow();
// alternate colors on rows
for($row =1; $row<$highestRow + 2; $row++) {
	//Set the colors, mid blue for the top row, with alternating white and light blue
	if ($row == 1) $color = '7799BB'; 
	else if ($row%2==0) $color = 'FFFFFF';
	else $color = 'EBEBEB';
// set the fill type and apply the color
$objPHPExcel->getActiveSheet()->getStyle('A' . $row . ':E' . $row)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
$objPHPExcel->getActiveSheet()->getStyle('A' . $row . ':E' . $row)->getFill()->getStartColor()->setRGB($color);
}

// bolds then centers column headers
$objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getFont()->setBold(true);
$objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

// set A1 as the selected cell, so the sheet will always be scrolled to top left (otherwise the last row/column manipulated will be active when the file is opened)
$objPHPExcel->getActiveSheet()->setSelectedCell('B1');


// writes the file out.  Saving to php://output sets the download prompt.
// to save file to server, pass a filename to save()
//$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

//$objWriter->save(str_replace('.php', '.xlsx', __FILE__));
$objWriter->save('php://output');


insert_timestamp($connect, 'item by contract', 'downloaded', $repID);

// clean up
sqlsrv_free_stmt($getReport);
sqlsrv_close($idConn);
mysqli_close($connect);
unset($checkSubmit);
exit;

}									// END CHECKSUBMIT == 4

} else {
 	echo "You can't see this page without submitting the form.";
}	
?>