<?php

/*
 *	Copyright 2011-2013 Benjamin Ingle
 *	The PSyOPs framework is licensed 
 *	under the GNU LGPL, version 2.1
 *	http://www.gnu.org/licenses/old-licenses/lgpl-2.1.txt
 */

/*	//DEBUG
foreach($_POST as $key => $value)
 echo $key."=".$value;
*/

ini_set('max_execution_time', 300);

include_once $_SERVER['DOCUMENT_ROOT'] . '/psyops_function.php';


if (array_key_exists('check_submit', $_POST)) {
	
$connect = connect_mysqli();
mysqli_select_db($connect, 'setup');

$cookie = ret_cookie($connect);
$repID = $cookie[0];
$level = $cookie[1];
unset($cookie);

$idConn = connect_sqlsrv();

$checkSubmit = sanitize($_POST['check_submit']);
$mfg = sanitize($_POST['mfg']);
$item = sanitize($_POST['item']);

setlocale(LC_MONETARY, 'en_US');


if ($checkSubmit == 4) {						// VIEW ITEM BY CONTRACT
	
$tsql = "select CustomerPricePlan.PricePlan, CustomerPricePlanDetail.MACCode, CustomerPricePlanDetail.SKU, 
	CustomerPricePlanDetail.Price, ItemVendor.Cost	
from (
		CustomerPricePlan left join CustomerPricePlanDetail 
		on CustomerPricePlan.Id = CustomerPricePlanDetail.PricePlanId
	) left join (
		Item left join ItemVendor on Item.Id = ItemVendor.ItemId
	) on CustomerPricePlanDetail.ItemId = Item.Id
	where CustomerPricePlanDetail.MACCode like (?)
		and CustomerPricePlanDetail.SKU like (?)
		and (Item.PurchaseVendorType = ItemVendor.VendorType
			and Item.PurchaseVendorSequence = ItemVendor.Sequence)";

$params = array($mfg, $item);

$options = array("Scrollable" => SQLSRV_CURSOR_KEYSET);
$getReport = sqlsrv_query($idConn, $tsql, $params, $options);

if ($getReport === false) {
	die(print_r(sqlsrv_errors()) );
}

									// 
echo ("
<script type='text/javascript'>
$(document).ready(function() 
    { 
	    $(document).ready(function() {
    	$('#viewtable').dataTable({
	    	'aaSorting': [[0,'asc']],
		    'bPaginate': false,
	        'bLengthChange': false,
	        'bFilter': true,
	        'bSort': true,
	        'bInfo': false,
	        'bAutoWidth': false
    	});
		});
    } 
); 
</script>
	<table border = '0' cellspacing='0' cellpadding='8' style='font-family:Arial, sans-serif;' id='viewtable' class='tablesorter'>
	<thead>
	<tr><td style='font-size:12px;font-weight:bold;color:#000000;'>Contract</td>
	<td style='font-size:12px;font-weight:bold;color:#000000;'>Mfg</td>
	<td style='font-size:12px;font-weight:bold;color:#000000;'>Item</td>
	<td style='font-size:12px;font-weight:bold;color:#000000;'>Price</td>
	<td style='font-size:12px;font-weight:bold;color:#000000;'>PurCost</td>
	<td style='font-size:12px;font-weight:bold;color:#000000;'>GP %</td>
	</tr></thead><tbody>"
	);

$i = 1;
while ($row = sqlsrv_fetch_array($getReport, SQLSRV_FETCH_NUMERIC)) {
	$gp = round(@(($row[3] - $row[4]) / $row[3]), 4) * 100;
		$gp = number_format($gp, 2, '.', '') . '%';
	$price = '$'.number_format($row[3], 2, '.', '');
	$cost = '$'.number_format($row[4], 2, '.', '');

/*// color alternate rows
if( $odd = $i%2 ) {
    // $odd == 1; the remainder of dividing an odd number
    $bgColor = 'BEBEBE';
} else {
    // $odd == 0; nothing remains 
    $bgColor = 'ECECEC';
}*/
     echo (
     "<tr><td style='font-size:12px;color:#000000;'>$row[0]</td>
     <td style='font-size:12px;color:#000000;'>$row[1]</td>
     <td style='font-size:12px;color:#000000;'>$row[2]</td>
     <td style='font-size:12px;color:#000000;'>$price</td>
     <td style='font-size:12px;color:#000000;'>$cost</td>
     <td style='font-size:12px;color:#000000;'>$gp</td>
     </tr>"
     );
  $i++;
}


echo ("</tbody></table></form></html>");


insert_timestamp($connect, 'item by contract', 'viewed', $repID);

// clean up
sqlsrv_free_stmt($getReport);
sqlsrv_close($idConn);
mysqli_close($connect);
exit;
}												// END CHECKSUBMIT == 4

} else {
 	echo "You can't see this page without submitting the form.";
}	

?>

