<?php

/*
 *	Copyright 2011-2013 Benjamin Ingle
 *	The PSyOPs framework is licensed 
 *	under the GNU LGPL, version 2.1
 *	http://www.gnu.org/licenses/old-licenses/lgpl-2.1.txt
 */

/*	//DEBUG
 foreach($_POST as $key => $value)
 echo $key."=".$value;
*/	

include_once $_SERVER['DOCUMENT_ROOT'] . '/psyops_function.php';

if (array_key_exists('check_submit', $_POST)) {
	
$connect = connect_mysqli();
mysqli_select_db($connect, 'setup');

$cookie = ret_cookie($connect);
$repID = $cookie[0];
$level = $cookie[1];
unset($cookie);

$idConn = connect_sqlsrv();
	
$checkSubmit = ($_POST['check_submit']);
$contract = ($_POST['custByContract']);
//$selDate = ('2012-02-03');

$date = (date('Y-m-d'));
$filename = 'Contract by Customer for '.$contract.' '.$date;	

// Redirect output to a clients web browser (Excel2007) 
//header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
//header("Content-Disposition: attachment; filename=".$filename.".xlsx" );
echo header("Content-Type: application/vnd.ms-excel");
echo header("Content-Disposition: attachment; filename=".$filename.".xls" );
echo header('Cache-Control: max-age=0');


if ($checkSubmit == 5) {						// VIEW CONTRACT
	
$tsql = "select Customer.Account, Customer.Department, Customer.Name, CustomerPricing.BestPricing, CustomerPricing.DiscountType, 
	CustomerPricing.DiscountPercent, CustomerPricing.HoldDiscount, CustomerPricing.HoldDiscountDays, CustomerPricing.PricePlan1, 
	CustomerPricing.PricePlan2, CustomerPricing.PricePlan3, CustomerPricing.PricePlan4, 
	convert(varchar(10),CustomerTotal.LastOrderDate,111), CustomerSalesPerson.UserId, [User].Name
from (Customer left join (
		CustomerPricing full join CustomerTotal on CustomerPricing.CustomerId = CustomerTotal.CustomerId
	) on Customer.Id = CustomerPricing.CustomerId
	) left join (
		[User] left join CustomerSalesPerson on [User].Id = CustomerSalesPerson.UserId
	) on CustomerSalesPerson.CustomerId = Customer.Id

where ((CustomerPricing.PricePlan1 = (?)) or (CustomerPricing.PricePlan2 = (?)) or 
	(CustomerPricing.PricePlan3 = (?)) or (CustomerPricing.PricePlan4 = (?)))
and CustomerSalesPerson.UserId != 'CLSE'
and CustomerSalesPerson.UserType = 'PRIMARY'
order by Customer.Account asc, Customer.Department asc";

$params = array($contract, $contract, $contract, $contract);
$options = array("Scrollable" => SQLSRV_CURSOR_KEYSET);
$getReport = sqlsrv_query($idConn, $tsql, $params, $options);

if ($getReport === false) {
	die( FormatErrors( sqlsrv_errors() ) );
}

/** Error reporting */
error_reporting(E_ALL);

/** Include path **/
ini_set('include_path', ini_get('include_path').'\\Classes\\');

/** PHPExcel */
include 'PHPExcel.php';

/** PHPExcel_Writer_Excel2007 */
include 'PHPExcel/Writer/Excel2007.php';

// Create new PHPExcel object
$objPHPExcel = new PHPExcel();

// Set properties
$objPHPExcel->getProperties()->setCreator("Benjamin Ingle");
$objPHPExcel->getProperties()->setLastModifiedBy("Benjamin Ingle");
$objPHPExcel->getProperties()->setTitle("Contract by Customer");
$objPHPExcel->getProperties()->setSubject("Contract by Customer");
$objPHPExcel->getProperties()->setDescription("Office 2002 XLS, generated using PHP classes.");
// Set column headers
$objPHPExcel->setActiveSheetIndex(0);
$objPHPExcel->getActiveSheet()->SetCellValue('A1', 'Account');
$objPHPExcel->getActiveSheet()->SetCellValue('B1', 'Dept');
$objPHPExcel->getActiveSheet()->SetCellValue('C1', 'Customer');
$objPHPExcel->getActiveSheet()->SetCellValue('D1', 'BP');
$objPHPExcel->getActiveSheet()->SetCellValue('E1', 'DT');
$objPHPExcel->getActiveSheet()->SetCellValue('F1', 'Disc %');
$objPHPExcel->getActiveSheet()->SetCellValue('G1', 'HT');
$objPHPExcel->getActiveSheet()->SetCellValue('H1', 'Floor %');
$objPHPExcel->getActiveSheet()->SetCellValue('I1', 'Cont1');
$objPHPExcel->getActiveSheet()->SetCellValue('J1', 'Cont2');
$objPHPExcel->getActiveSheet()->SetCellValue('K1', 'Cont3');
$objPHPExcel->getActiveSheet()->SetCellValue('L1', 'Cont4');
$objPHPExcel->getActiveSheet()->SetCellValue('M1', 'Last Order');
$objPHPExcel->getActiveSheet()->SetCellValue('N1', 'Slsm');
$objPHPExcel->getActiveSheet()->SetCellValue('O1', 'Slsm Name');

// Rename sheet
$objPHPExcel->getActiveSheet()->setTitle('Contract by Customer - '.$contract);

$objPHPExcel->getActiveSheet()->getPageSetup()->setRowsToRepeatAtTopByStartAndEnd(1, 1);

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objPHPExcel->setActiveSheetIndex(0);

// Allow setting explicit text values (eg, dept needs leading zeroes)
$type = PHPExcel_Cell_DataType::TYPE_STRING;
// Add data
$numRows = 0;
$numRows = sqlsrv_num_rows($getReport);
	$i = 2;
	while ($row = sqlsrv_fetch_array($getReport, SQLSRV_FETCH_NUMERIC)) {
			$acct = trim($row[0]);
			$dept = trim($row[1]);
			$floor = trim($row[7]) . '%';
		$objPHPExcel->getActiveSheet()->getCell('A' . $i)->setValueExplicit($acct, $type);
		$objPHPExcel->getActiveSheet()->getCell('B' . $i)->setValueExplicit($dept, $type);
		$objPHPExcel->getActiveSheet()->setCellValue('C' . $i, $row[2]);
		$objPHPExcel->getActiveSheet()->setCellValue('D' . $i, $row[3]);
		$objPHPExcel->getActiveSheet()->setCellValue('E' . $i, $row[4]);
		$objPHPExcel->getActiveSheet()->setCellValue('F' . $i, $row[5]);
		$objPHPExcel->getActiveSheet()->setCellValue('G' . $i, $row[6]);											
		$objPHPExcel->getActiveSheet()->getCell('H' . $i)->setValueExplicit($floor, $type);
		$objPHPExcel->getActiveSheet()->setCellValue('I' . $i, $row[8]);					// 
		$objPHPExcel->getActiveSheet()->setCellValue('J' . $i, $row[9]);
		$objPHPExcel->getActiveSheet()->setCellValue('K' . $i, $row[10]);
		$objPHPExcel->getActiveSheet()->setCellValue('L' . $i, $row[11]);											
		$objPHPExcel->getActiveSheet()->setCellValue('M' . $i, $row[12]);
		$objPHPExcel->getActiveSheet()->setCellValue('N' . $i, $row[13]);					
		$objPHPExcel->getActiveSheet()->setCellValue('O' . $i, $row[14]);
		$i++;									// =IF(D2=0,C2,C2/D2)										
	}
	


// set columns to width by AutoSize (not perfect, but close enough)
$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('I')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('J')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('K')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('L')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('M')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('N')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('O')->setAutoSize(true);

// set certain columns to fixed width (AutoSize not close enough in this case)
$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth(7);
/*$objPHPExcel->getActiveSheet()->getColumnDimension('I')->setWidth(7);
$objPHPExcel->getActiveSheet()->getColumnDimension('J')->setWidth(15);*/

$h = ($i - 1);

// sets to proper percentage format, two digits to right of decimal
$objPHPExcel->getActiveSheet()->getStyle('F2:F'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_PERCENTAGE_00);
// right-align column A, to align account #s
$objPHPExcel->getActiveSheet()->getStyle('A2:A'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
// left-align column B, to align depts
$objPHPExcel->getActiveSheet()->getStyle('B2:C'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
$objPHPExcel->getActiveSheet()->getStyle('N2:O'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
// center remaining columns through M
$objPHPExcel->getActiveSheet()->getStyle('D2:M'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

// freeze top row (must freeze X+1 - to freeze top row, call freezePane on A2)
$objPHPExcel->getActiveSheet()->freezePane('A2');


$highestRow = $objPHPExcel->getActiveSheet()->getHighestRow();
// alternate colors on rows
for($row =1; $row<$highestRow + 2; $row++) {
	//Set the colors, mid blue for the top row, with alternating white and light blue
	if ($row == 1) $color = '7799BB'; 
	else if ($row%2==0) $color = 'FFFFFF';
	else $color = 'EBEBEB';
// set the fill type and apply the color
$objPHPExcel->getActiveSheet()->getStyle('A' . $row . ':O' . $row)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
$objPHPExcel->getActiveSheet()->getStyle('A' . $row . ':O' . $row)->getFill()->getStartColor()->setRGB($color);
}

// bolds then centers column headers
$objPHPExcel->getActiveSheet()->getStyle('A1:O1')->getFont()->setBold(true);
$objPHPExcel->getActiveSheet()->getStyle('A1:O1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

// set A1 as the selected cell, so the sheet will always be scrolled to top left (otherwise the last row/column manipulated will be active when the file is opened)
$objPHPExcel->getActiveSheet()->setSelectedCell('B1');


// write file footers
$objPHPExcel->getActiveSheet()->getHeaderFooter()->setOddFooter('&R' . $objPHPExcel->getProperties()->getTitle() . '&RPage &P of &N');
$objPHPExcel->getActiveSheet()->getHeaderFooter()->setOddFooter('&R' . $objPHPExcel->getProperties()->getTitle() . '&C&F');
$objPHPExcel->getActiveSheet()->getHeaderFooter()->setEvenFooter('&R' . $objPHPExcel->getProperties()->getTitle() . '&L&D &T');

// writes the file out.  Saving to php://output sets the download prompt.
// to save file to server, pass a filename to save()
//$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

//$objWriter->save(str_replace('.php', '.xlsx', __FILE__));
$objWriter->save('php://output');


insert_timestamp($connect, 'cust by contract', 'downloaded', $repID);

// clean up
sqlsrv_free_stmt($getReport);
sqlsrv_close($idConn);
mysqli_close($connect);
unset($checkSubmit);
exit;

}								// END CHECKSUBMIT == 5


} else {
 	echo "You can't see this page without submitting the form.";
}	
?>