<?php

/*
 *	Copyright 2011-2013 Benjamin Ingle
 *	The PSyOPs framework is licensed 
 *	under the GNU LGPL, version 2.1
 *	http://www.gnu.org/licenses/old-licenses/lgpl-2.1.txt
 */


global $repID, $dConn, $db, $ssConn;


// sanitizes text inputs from all input forms
function sanitize($str){
    $forbidden=array("<", // HTML + logical operator
     ">", // HTML + logical operator
     "'", // SQL string operator
     "\"", // SQL string operator
     "%", // SQL string operator
     "*",  
     "", 
     "`", 
     "=");
    for ($i=0; $i<count($forbidden); $i++) {
 $repl=$forbidden[$i];
 $str=str_replace("$repl","",$str);
    }
    return ($str);
}


// retrieves cookie, which contains user id - used for the ret_timestamp and insert_timestamp funcs
function ret_cookie($conn) {
	global $repID;
	if (isset($_COOKIE["id"])) {
		$repID = $_COOKIE["id"];
		$queryString = "SELECT level FROM reps WHERE '$repID' = ddms_id ";
		$Qry = mysqli_query($conn, $queryString);
			if ($Qry == false) {
				echo $Qry;
				die('error in query: ' . mysqli_error($Qry));
			}
		$id = mysqli_fetch_array($Qry);
	
		$level = $id[0];
		if ($_COOKIE["id"] == 'dev') {
			$repID = 'dev';
			$level = 7;
		}
	} else {
		$repID = 'null';
		$level = 0;
	}
	return $repID;
}


// retrieves timestamp from last_updated table, per user
function ret_timestamp($conn, $rpt_name) {
	global $repID;
	$queryString = "SELECT max(timestamp) , func_perf
		FROM last_updated
		WHERE timestamp = ( 
		SELECT max(timestamp)) 
		AND user_id = '$repID'
		AND report_name = '$rpt_name'";
	$Qry = mysqli_query($conn, $queryString);
	$qryRes = mysqli_fetch_array($Qry);
	$rptTime = substr($qryRes[0],0,10);
	$rptFunc = $qryRes[1];
		if (!$rptFunc) {
			$rptTime = 'never';
		}
	return $rptTime;
}  

// retrieves timestamp from information_schema, to report a table's last updated time
// (this allegedly will not work on InnoDB tables)
function ret_table_update($conn, $db, $table_name) {
	$queryString = "SELECT UPDATE_TIME
	FROM   information_schema.tables
	WHERE  TABLE_SCHEMA = '$db'
   		AND TABLE_NAME = '$table_name'";
   	$Qry = mysqli_query($conn, $queryString);
   	$qryRes = mysqli_fetch_array($Qry);
	$rptTime = $qryRes[0];
	
	return $rptTime;
}
	

// inserts timestamp to mysql last_updated table, report name and type - viewed or downloaded
function insert_timestamp($conn, $rpt_name, $func_perf, $repID) {
	global $repID;
	$values = ("'$rpt_name', '$func_perf', '$repID'");
	$columns = ("report_name, func_perf, user_id");
	if ($repID == 'dev') { $table = 'dev_updated'; } 
	else { $table = 'last_updated'; }
	$queryString = "INSERT INTO $table ($columns) VALUES ($values)";
	$Qry = mysqli_query($conn, $queryString);
		if ($Qry = 'false') {
			echo mysqli_error($conn) . "<br />";
		}
}

function insert_dev_timestamp($conn, $rpt_name, $func_perf, $repID) {
	global $repID;
	$values = ("'$rpt_name', '$func_perf', '$repID'");
	$columns = ("report_name, func_perf, user_id");
	$queryString = "INSERT INTO dev_updated ($columns) VALUES ($values)";
	$Qry = mysqli_query($conn, $queryString);
		if ($Qry = 'false') {
			echo mysqli_error($conn) . "<br />";
		}
}


// return last modified date from file
function last_modified($filename, $path) {
	$mTime = filemtime($path . $filename);
	$last_mod = date ("Y-m-d H:i:s.", $mTime);
	return $last_mod;
}


// connect to the mysql database
function connect_mysqli() {
	$user = 'sandbox';
	$pass = 'TNhU5AX2ZnaQHFVq';

	
	$iConn = mysqli_connect("localhost",$user,$pass);
		if (!$iConn) {
	  		die('Could not connect: ' . mysqli_error($iConn));
	  	}

	return $iConn;
}	

// connect to sqlserver database
function connect_sqlsrv() {
	global $ssConn;
	$serverName = "COS-DDMS2\ECI2";
	$connectionOptions = array("Database"=>"Ensite","UID"=>"NetClient","PWD"=>"db_user", "ReturnDatesAsStrings" => 1);
	$ssConn = sqlsrv_connect($serverName, $connectionOptions);
	
	if( $ssConn === false ) {
		die(print_r(sqlsrv_errors()));
	}
	return $ssConn;
}


?>